# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from alfresco_core_api_client.api_client import ApiClient


class StorageInfoApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_storage_properties(self, node_id, content_prop_name, **kwargs):  # noqa: E501
        """Retrieve storage properties for given content  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Gets storage properties for given content.  Please find below sample responses for this endpoint when Alfresco Content Connector for AWS S3 is installed.  Similar responses will be returned when Alfresco Content Connector for Azure Blob is installed, albeit it with  some native storage properties with x-ms- prefix instead of x-amz- prefix.  Standard storage class: ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"false\"     },     \"id\": \"cm:content\"   } } ``` Intelligent tiering storage class: ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"false\",       \"x-amz-storage-class\": \"INTELLIGENT_TIERING\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (no restore request ongoing or submitted): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"true\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (restore request ongoing, not completed): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archive-restore-in-progress\": \"true\",       \"x-amz-restore\": \"ongoing-request=\\\"true\\\"\",       \"x-alf-archived\": \"true\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (restore request completed): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archive-restore-in-progress\": \"false\",       \"x-amz-restore\": \"ongoing-request=\\\"false\\\", expiry-date=\\\"Fri Nov 26 01:00:00 CET 2021\\\"\",       \"x-alf-archive-restore-expiry\": \"2021-11-26T00:00:00.000Z\",       \"x-alf-archived\": \"false\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ```   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_storage_properties(node_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :return: ContentStorageInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_storage_properties_with_http_info(node_id, content_prop_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_storage_properties_with_http_info(node_id, content_prop_name, **kwargs)  # noqa: E501
            return data

    def get_storage_properties_with_http_info(self, node_id, content_prop_name, **kwargs):  # noqa: E501
        """Retrieve storage properties for given content  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Gets storage properties for given content.  Please find below sample responses for this endpoint when Alfresco Content Connector for AWS S3 is installed.  Similar responses will be returned when Alfresco Content Connector for Azure Blob is installed, albeit it with  some native storage properties with x-ms- prefix instead of x-amz- prefix.  Standard storage class: ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"false\"     },     \"id\": \"cm:content\"   } } ``` Intelligent tiering storage class: ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"false\",       \"x-amz-storage-class\": \"INTELLIGENT_TIERING\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (no restore request ongoing or submitted): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"true\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (restore request ongoing, not completed): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archive-restore-in-progress\": \"true\",       \"x-amz-restore\": \"ongoing-request=\\\"true\\\"\",       \"x-alf-archived\": \"true\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (restore request completed): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archive-restore-in-progress\": \"false\",       \"x-amz-restore\": \"ongoing-request=\\\"false\\\", expiry-date=\\\"Fri Nov 26 01:00:00 CET 2021\\\"\",       \"x-alf-archive-restore-expiry\": \"2021-11-26T00:00:00.000Z\",       \"x-alf-archived\": \"false\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ```   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_storage_properties_with_http_info(node_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :return: ContentStorageInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['node_id', 'content_prop_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_storage_properties" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'node_id' is set
        if self.api_client.client_side_validation and ('node_id' not in params or
                                                       params['node_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `node_id` when calling `get_storage_properties`")  # noqa: E501
        # verify the required parameter 'content_prop_name' is set
        if self.api_client.client_side_validation and ('content_prop_name' not in params or
                                                       params['content_prop_name'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `content_prop_name` when calling `get_storage_properties`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'node_id' in params:
            path_params['nodeId'] = params['node_id']  # noqa: E501
        if 'content_prop_name' in params:
            path_params['contentPropName'] = params['content_prop_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/{nodeId}/storage-info/{contentPropName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ContentStorageInfo',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_version_storage_properties(self, node_id, version_id, content_prop_name, **kwargs):  # noqa: E501
        """Retrieve storage properties for given version content  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Gets storage properties for given version content.  Please find below sample responses for this endpoint when Alfresco Content Connector for AWS S3 is installed.  Similar responses will be returned when Alfresco Content Connector for Azure Blob is installed, albeit it with  some native storage properties with x-ms- prefix instead of x-amz- prefix.  Standard storage class: ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"false\"     },     \"id\": \"cm:content\"   } } ``` Intelligent tiering storage class: ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"false\",       \"x-amz-storage-class\": \"INTELLIGENT_TIERING\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (no restore request ongoing or submitted): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"true\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (restore request ongoing, not completed): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archive-restore-in-progress\": \"true\",       \"x-amz-restore\": \"ongoing-request=\\\"true\\\"\",       \"x-alf-archived\": \"true\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (restore request completed): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archive-restore-in-progress\": \"false\",       \"x-amz-restore\": \"ongoing-request=\\\"false\\\", expiry-date=\\\"Fri Nov 26 01:00:00 CET 2021\\\"\",       \"x-alf-archive-restore-expiry\": \"2021-11-26T00:00:00.000Z\",       \"x-alf-archived\": \"false\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ```   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_version_storage_properties(node_id, version_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str version_id: The identifier of a version, ie. version label, within the version history of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :return: ContentStorageInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_version_storage_properties_with_http_info(node_id, version_id, content_prop_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_version_storage_properties_with_http_info(node_id, version_id, content_prop_name, **kwargs)  # noqa: E501
            return data

    def get_version_storage_properties_with_http_info(self, node_id, version_id, content_prop_name, **kwargs):  # noqa: E501
        """Retrieve storage properties for given version content  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Gets storage properties for given version content.  Please find below sample responses for this endpoint when Alfresco Content Connector for AWS S3 is installed.  Similar responses will be returned when Alfresco Content Connector for Azure Blob is installed, albeit it with  some native storage properties with x-ms- prefix instead of x-amz- prefix.  Standard storage class: ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"false\"     },     \"id\": \"cm:content\"   } } ``` Intelligent tiering storage class: ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"false\",       \"x-amz-storage-class\": \"INTELLIGENT_TIERING\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (no restore request ongoing or submitted): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archived\": \"true\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (restore request ongoing, not completed): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archive-restore-in-progress\": \"true\",       \"x-amz-restore\": \"ongoing-request=\\\"true\\\"\",       \"x-alf-archived\": \"true\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ``` Glacier archive storage class (restore request completed): ```json {   \"entry\": {     \"storageProperties\": {       \"x-alf-archive-restore-in-progress\": \"false\",       \"x-amz-restore\": \"ongoing-request=\\\"false\\\", expiry-date=\\\"Fri Nov 26 01:00:00 CET 2021\\\"\",       \"x-alf-archive-restore-expiry\": \"2021-11-26T00:00:00.000Z\",       \"x-alf-archived\": \"false\",       \"x-amz-storage-class\": \"GLACIER\"     },     \"id\": \"cm:content\"   } } ```   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_version_storage_properties_with_http_info(node_id, version_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str version_id: The identifier of a version, ie. version label, within the version history of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :return: ContentStorageInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['node_id', 'version_id', 'content_prop_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_version_storage_properties" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'node_id' is set
        if self.api_client.client_side_validation and ('node_id' not in params or
                                                       params['node_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `node_id` when calling `get_version_storage_properties`")  # noqa: E501
        # verify the required parameter 'version_id' is set
        if self.api_client.client_side_validation and ('version_id' not in params or
                                                       params['version_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `version_id` when calling `get_version_storage_properties`")  # noqa: E501
        # verify the required parameter 'content_prop_name' is set
        if self.api_client.client_side_validation and ('content_prop_name' not in params or
                                                       params['content_prop_name'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `content_prop_name` when calling `get_version_storage_properties`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'node_id' in params:
            path_params['nodeId'] = params['node_id']  # noqa: E501
        if 'version_id' in params:
            path_params['versionId'] = params['version_id']  # noqa: E501
        if 'content_prop_name' in params:
            path_params['contentPropName'] = params['content_prop_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/{nodeId}/versions/{versionId}/storage-info/{contentPropName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ContentStorageInfo',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def request_archive_content(self, node_id, content_prop_name, **kwargs):  # noqa: E501
        """Request to send given content to archive  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Request to send given content to archive.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.request_archive_content(node_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :param ArchiveContentRequest archive_content_request: Archive content request parameters - currently not supported by any Alfresco Cloud Connector. Body is not mandatory. Request body example: ```JSON {   \"archiveParams\": {                 \"x-amz-storage-class\": \"GLACIER\"               } } ``` 
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.request_archive_content_with_http_info(node_id, content_prop_name, **kwargs)  # noqa: E501
        else:
            (data) = self.request_archive_content_with_http_info(node_id, content_prop_name, **kwargs)  # noqa: E501
            return data

    def request_archive_content_with_http_info(self, node_id, content_prop_name, **kwargs):  # noqa: E501
        """Request to send given content to archive  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Request to send given content to archive.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.request_archive_content_with_http_info(node_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :param ArchiveContentRequest archive_content_request: Archive content request parameters - currently not supported by any Alfresco Cloud Connector. Body is not mandatory. Request body example: ```JSON {   \"archiveParams\": {                 \"x-amz-storage-class\": \"GLACIER\"               } } ``` 
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['node_id', 'content_prop_name', 'archive_content_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method request_archive_content" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'node_id' is set
        if self.api_client.client_side_validation and ('node_id' not in params or
                                                       params['node_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `node_id` when calling `request_archive_content`")  # noqa: E501
        # verify the required parameter 'content_prop_name' is set
        if self.api_client.client_side_validation and ('content_prop_name' not in params or
                                                       params['content_prop_name'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `content_prop_name` when calling `request_archive_content`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'node_id' in params:
            path_params['nodeId'] = params['node_id']  # noqa: E501
        if 'content_prop_name' in params:
            path_params['contentPropName'] = params['content_prop_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'archive_content_request' in params:
            body_params = params['archive_content_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/{nodeId}/storage-info/{contentPropName}/archive', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def request_archive_version_content(self, node_id, version_id, content_prop_name, **kwargs):  # noqa: E501
        """Request to send given version content to archive  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Request to send given version content to archive.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.request_archive_version_content(node_id, version_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str version_id: The identifier of a version, ie. version label, within the version history of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :param ArchiveContentRequest archive_content_request: Archive content request parameters - currently not supported by any Alfresco Cloud Connector. Body is not mandatory. Request body example: ```JSON {   \"archiveParams\": {                 \"x-amz-storage-class\": \"GLACIER\"               } } ``` 
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.request_archive_version_content_with_http_info(node_id, version_id, content_prop_name, **kwargs)  # noqa: E501
        else:
            (data) = self.request_archive_version_content_with_http_info(node_id, version_id, content_prop_name, **kwargs)  # noqa: E501
            return data

    def request_archive_version_content_with_http_info(self, node_id, version_id, content_prop_name, **kwargs):  # noqa: E501
        """Request to send given version content to archive  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Request to send given version content to archive.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.request_archive_version_content_with_http_info(node_id, version_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str version_id: The identifier of a version, ie. version label, within the version history of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :param ArchiveContentRequest archive_content_request: Archive content request parameters - currently not supported by any Alfresco Cloud Connector. Body is not mandatory. Request body example: ```JSON {   \"archiveParams\": {                 \"x-amz-storage-class\": \"GLACIER\"               } } ``` 
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['node_id', 'version_id', 'content_prop_name', 'archive_content_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method request_archive_version_content" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'node_id' is set
        if self.api_client.client_side_validation and ('node_id' not in params or
                                                       params['node_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `node_id` when calling `request_archive_version_content`")  # noqa: E501
        # verify the required parameter 'version_id' is set
        if self.api_client.client_side_validation and ('version_id' not in params or
                                                       params['version_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `version_id` when calling `request_archive_version_content`")  # noqa: E501
        # verify the required parameter 'content_prop_name' is set
        if self.api_client.client_side_validation and ('content_prop_name' not in params or
                                                       params['content_prop_name'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `content_prop_name` when calling `request_archive_version_content`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'node_id' in params:
            path_params['nodeId'] = params['node_id']  # noqa: E501
        if 'version_id' in params:
            path_params['versionId'] = params['version_id']  # noqa: E501
        if 'content_prop_name' in params:
            path_params['contentPropName'] = params['content_prop_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'archive_content_request' in params:
            body_params = params['archive_content_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/{nodeId}/versions/{versionId}/storage-info/{contentPropName}/archive', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def request_restore_content_from_archive(self, node_id, content_prop_name, **kwargs):  # noqa: E501
        """Request to restore given content from archive  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Request to restore given content from archive.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.request_restore_content_from_archive(node_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :param RestoreArchivedContentRequest restore_archived_content_request: Restore content from archive request parameters. At the moment there is one parameter being supported which is restore priority. 'High' restore priority translates to 'Expedited' Glacier restore tier in AWS S3 and 'High' rehydrate priority in Azure Blob. 'Standard' restore priority translates to 'Standard' Glacier restore tier in AWS S3 and 'Standard' rehydrate priority in Azure Blob. Body is not mandatory. High restore priority request body example: ```JSON {   \"restorePriority\": \"High\" } ``` Standard restore priority request body example: ```JSON {   \"restorePriority\": \"Standard\" } ``` 
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.request_restore_content_from_archive_with_http_info(node_id, content_prop_name, **kwargs)  # noqa: E501
        else:
            (data) = self.request_restore_content_from_archive_with_http_info(node_id, content_prop_name, **kwargs)  # noqa: E501
            return data

    def request_restore_content_from_archive_with_http_info(self, node_id, content_prop_name, **kwargs):  # noqa: E501
        """Request to restore given content from archive  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Request to restore given content from archive.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.request_restore_content_from_archive_with_http_info(node_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :param RestoreArchivedContentRequest restore_archived_content_request: Restore content from archive request parameters. At the moment there is one parameter being supported which is restore priority. 'High' restore priority translates to 'Expedited' Glacier restore tier in AWS S3 and 'High' rehydrate priority in Azure Blob. 'Standard' restore priority translates to 'Standard' Glacier restore tier in AWS S3 and 'Standard' rehydrate priority in Azure Blob. Body is not mandatory. High restore priority request body example: ```JSON {   \"restorePriority\": \"High\" } ``` Standard restore priority request body example: ```JSON {   \"restorePriority\": \"Standard\" } ``` 
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['node_id', 'content_prop_name', 'restore_archived_content_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method request_restore_content_from_archive" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'node_id' is set
        if self.api_client.client_side_validation and ('node_id' not in params or
                                                       params['node_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `node_id` when calling `request_restore_content_from_archive`")  # noqa: E501
        # verify the required parameter 'content_prop_name' is set
        if self.api_client.client_side_validation and ('content_prop_name' not in params or
                                                       params['content_prop_name'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `content_prop_name` when calling `request_restore_content_from_archive`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'node_id' in params:
            path_params['nodeId'] = params['node_id']  # noqa: E501
        if 'content_prop_name' in params:
            path_params['contentPropName'] = params['content_prop_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'restore_archived_content_request' in params:
            body_params = params['restore_archived_content_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/{nodeId}/storage-info/{contentPropName}/archive-restore', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def request_restore_version_content_from_archive(self, node_id, version_id, content_prop_name, **kwargs):  # noqa: E501
        """Request to restore given version content from archive  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Request to restore given version content from archive.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.request_restore_version_content_from_archive(node_id, version_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str version_id: The identifier of a version, ie. version label, within the version history of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :param RestoreArchivedContentRequest restore_archived_content_request: Restore content from archive request parameters. At the moment there is one parameter being supported which is restore priority. 'High' restore priority translates to 'Expedited' Glacier restore tier in AWS S3 and 'High' rehydrate priority in Azure Blob. 'Standard' restore priority translates to 'Standard' Glacier restore tier in AWS S3 and 'Standard' rehydrate priority in Azure Blob. Body is not mandatory. High restore priority request body example: ```JSON {   \"restorePriority\": \"High\" } ``` Standard restore priority request body example: ```JSON {   \"restorePriority\": \"Standard\" } ``` 
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.request_restore_version_content_from_archive_with_http_info(node_id, version_id, content_prop_name, **kwargs)  # noqa: E501
        else:
            (data) = self.request_restore_version_content_from_archive_with_http_info(node_id, version_id, content_prop_name, **kwargs)  # noqa: E501
            return data

    def request_restore_version_content_from_archive_with_http_info(self, node_id, version_id, content_prop_name, **kwargs):  # noqa: E501
        """Request to restore given version content from archive  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.2.0 and newer versions. It also requires at least one specific implementation of underlying functionality in Cloud Connector(s).  Request to restore given version content from archive.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.request_restore_version_content_from_archive_with_http_info(node_id, version_id, content_prop_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str version_id: The identifier of a version, ie. version label, within the version history of a node. (required)
        :param str content_prop_name: The namespace-prefix property name of content. Delimiter between namespace-prefix and property name can be either colon (':') or underscore ('_') character (e.g., 'cm:content' or 'cm_content').  (required)
        :param RestoreArchivedContentRequest restore_archived_content_request: Restore content from archive request parameters. At the moment there is one parameter being supported which is restore priority. 'High' restore priority translates to 'Expedited' Glacier restore tier in AWS S3 and 'High' rehydrate priority in Azure Blob. 'Standard' restore priority translates to 'Standard' Glacier restore tier in AWS S3 and 'Standard' rehydrate priority in Azure Blob. Body is not mandatory. High restore priority request body example: ```JSON {   \"restorePriority\": \"High\" } ``` Standard restore priority request body example: ```JSON {   \"restorePriority\": \"Standard\" } ``` 
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['node_id', 'version_id', 'content_prop_name', 'restore_archived_content_request']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method request_restore_version_content_from_archive" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'node_id' is set
        if self.api_client.client_side_validation and ('node_id' not in params or
                                                       params['node_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `node_id` when calling `request_restore_version_content_from_archive`")  # noqa: E501
        # verify the required parameter 'version_id' is set
        if self.api_client.client_side_validation and ('version_id' not in params or
                                                       params['version_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `version_id` when calling `request_restore_version_content_from_archive`")  # noqa: E501
        # verify the required parameter 'content_prop_name' is set
        if self.api_client.client_side_validation and ('content_prop_name' not in params or
                                                       params['content_prop_name'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `content_prop_name` when calling `request_restore_version_content_from_archive`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'node_id' in params:
            path_params['nodeId'] = params['node_id']  # noqa: E501
        if 'version_id' in params:
            path_params['versionId'] = params['version_id']  # noqa: E501
        if 'content_prop_name' in params:
            path_params['contentPropName'] = params['content_prop_name']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'restore_archived_content_request' in params:
            body_params = params['restore_archived_content_request']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/{nodeId}/versions/{versionId}/storage-info/{contentPropName}/archive-restore', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
